/******************** (C) COPYRIGHT 2006 STMicroelectronics ********************
* File Name          : main.c
* Author             : MCD Application Team
* Date First Issued  : 05/18/2006 : Version 1.0
* Description        : main program for DMA example.
*
********************************************************************************
* History:
* 05/24/2006 : Version 1.1
* 05/18/2006 : Version 1.0
********************************************************************************
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Standard include ----------------------------------------------------------*/
#include "91x_lib.h"

/* Include of other module interface headers ---------------------------------*/
/* Local includes ------------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/*******************************************************************************
* Function Name  : main
* Description    : Main program
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
#define DEBUG
#include <91x_lib.h>


DMA_InitTypeDef  DMA_InitStruct;


volatile u32 Link[12] ={0x00000000,0x00000000,0x0000000,0x0C48900C,0x00000000,0x00000000,0x04000808,0x0C48900C,0x4000020,0x40002040,0x00000000,0x0C48900C};

volatile u32 Buffer0[36] ={0,1,2,3,4,4,3,2,1,6,7,81,92,3,4,14,13,20,1,6,70,8,92,3,40,4,3,20,1,6,7,82,9,2,1,4};

volatile u32 Buffer1[12] ={0,0,0,0,0,0,0,0,0,0,0,0};
volatile u32 Buffer2[12] ={0,0,0,0,0,0,0,0,0,0,0,0};
volatile u32 Buffer3[12] ={0,0,0,0,0,0,0,0,0,0,0,0};

/******************************************************************************
******************** C Main function for UART polling example *****************
*******************************************************************************/

void main(void)
{


#ifdef DEBUG
  debug();
#endif


  /*Set the linked list item content in the memory: source addresses and destination addresses */


   Link[4]=(u32)(&Buffer0[12]);
   Link[5]=(u32)(&Buffer2[0]);

   Link[8]=(u32)(&Buffer0[24]);
   Link[9]=(u32)(&Buffer3[0]);



   /*Set the linked list item content in the memory: addresses of next linked lists*/
   Link[2]=(u32)(&Link[4]);
   Link[6]=(u32)(&Link[8]);



   SCU_AHBPeriphClockConfig(__DMA,ENABLE); /* Enable the clock for DMA*/
   DMA_DeInit(); /* DMA default configuration : Reset configuration*/
   DMA_Cmd(ENABLE);/*Enable the DMA*/
   DMA_StructInit(&DMA_InitStruct);

   /* Write the first LLI*/
   DMA_InitStruct.DMA_Channel_LLstItm=Link[2];
   DMA_InitStruct.DMA_Channel_SrcAdd=(u32)(&Buffer0[0]);
   DMA_InitStruct.DMA_Channel_DesAdd=(u32)(&Buffer1[0]);
   DMA_InitStruct.DMA_Channel_SrcWidth= DMA_SrcWidth_Word;
   DMA_InitStruct.DMA_Channel_DesWidth= DMA_DesWidth_Word;
   DMA_InitStruct.DMA_Channel_FlowCntrl=DMA_FlowCntrlt0_DMA;
   DMA_InitStruct.DMA_Channel_TrsfSize =12;



  /* Configure the DMA channel1 "the chosen channel to perform the transfer" */

  DMA_ChannelSRCIncConfig (DMA_Channel1, ENABLE);
  DMA_ChannelDESIncConfig (DMA_Channel1, ENABLE);


  DMA_Init(DMA_Channel1,&DMA_InitStruct);
  DMA_ChannelCmd (DMA_Channel1,ENABLE);/*Enable the DMA channel*/



  /*wait for the fifo to be empty*/
  while(DMA_GetChannelActiveStatus(DMA_Channel1));

 while(1);

}

/******************* (C) COPYRIGHT 2006 STMicroelectronics *****END OF FILE****/
